"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/** Modes for displaying the game collection at the BrowsePage */
var BrowsePageLayout;
(function (BrowsePageLayout) {
    /** Games are in a vertical list, one game per row */
    BrowsePageLayout[BrowsePageLayout["list"] = 0] = "list";
    /** Games are in a table-like grid, each cell is a game */
    BrowsePageLayout[BrowsePageLayout["grid"] = 1] = "grid";
})(BrowsePageLayout = exports.BrowsePageLayout || (exports.BrowsePageLayout = {}));
/** Convert a BrowsePageLayout value to a string (returns undefined if value is invalid) */
function stringifyBrowsePageLayout(layout) {
    switch (layout) {
        case BrowsePageLayout.list: return 'list';
        case BrowsePageLayout.grid: return 'grid';
    }
    return undefined;
}
exports.stringifyBrowsePageLayout = stringifyBrowsePageLayout;
/** Convert a string to a BrowsePageLayout value (returns undefined if string is invalid) */
function parseBrowsePageLayout(str) {
    switch (str) {
        case 'list': return BrowsePageLayout.list;
        case 'grid': return BrowsePageLayout.grid;
    }
    return undefined;
}
exports.parseBrowsePageLayout = parseBrowsePageLayout;
//# sourceMappingURL=BrowsePageLayout.js.map